package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadCOStatusCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadCOStatusTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadCOStatusTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取一氧化碳参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadCOStatusCommand coAlmCmd = (ReadCOStatusCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(coAlmCmd.getCommandType());
		cmd.setDest(coAlmCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { coAlmCmd.getMemoryArea() }));
		cmd.setStart_mem_word(coAlmCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(coAlmCmd.getStartAddress().substring(4));
		cmd.setCount_word(coAlmCmd.getCountWord());
		cmd.setCount_bit(coAlmCmd.getCountBit());
		cmd.setCount_sensor(coAlmCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
